<?php

class Jooble
{
	public $jooble_uri = '';
	private static $API_SEARCH_REQUIRED = array( array( 'q', 'l' ) );
	private static $API_JOBS_REQUIRED   = array( 'jobkeys' );
	public function __construct( $api_key, $country = 'us' ){
		$this->api_key = $api_key;
		$this->country   = $country;
		$this->jooble_uri = "https://{$this->country}.jooble.org/api/";
	}

	public function search( $args = array() ){
		return $this->process_request( $this->jooble_uri, $this->validate_args( self::$API_SEARCH_REQUIRED, $args ) );
	}

	private function process_request($url, $args) {
		$keyword = $args['q'];
		$location = $args['l'];
		$error = '';
		if(apply_filters('noo_jobs_import_use_wp_request', true)){
			$response = wp_remote_post($url.$this->api_key,array(
				'headers' => array(
					'Content-Type' => 'application/json'
				),
				'method' => 'POST',
				'httpversion' => '1.0',
				'sslverify' => false,
				'body' => json_encode(array(
					'keywords' => $keyword,
					'location' => $location
				))
			));
			$response_code = wp_remote_retrieve_response_code($response);
			if(is_wp_error($response) || $response_code != 200){
				if(is_wp_error($response)){
					$error = $response->get_error_message();
				}else{
					$error = wp_remote_retrieve_response_message($response);
				}
			}else{
				$result = wp_remote_retrieve_body($response);
			}
		}else{
			//create request object
			$ch = curl_init();
			curl_setopt($ch, CURLOPT_URL, $url."".$this->api_key);
			curl_setopt($ch, CURLOPT_POST, 1);
			curl_setopt($ch, CURLOPT_POSTFIELDS, '{ "keywords": "'.$keyword.'", "location": "'.$location.'" }');
			curl_setopt($ch, CURLOPT_HTTPHEADER, array('Content-Type: application/x-www-form-urlencoded'));
			
			// receive server response ...
			curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
			
			$result = curl_exec ($ch);
			$error = curl_error($ch);
			curl_close ($ch);
		}
		if (!empty($error)) {
			return new WP_Error('jooble_error',$error);
		} else {
			return $result;
		}
	}

	private function validate_args($required_fields, $args){
		foreach($required_fields as $field){
			if( is_array( $field ) ){
				$has_one_required = false;
				foreach($field as $f){
					if(array_key_exists($f, $args)){
						$has_one_required = True;
						break;
					}
				}
				if( !$has_one_required ){
					throw new Exception(sprintf( esc_html__( "You must provide one of the following %s", 'noo' ) , implode(",", $field)));
				}
			} elseif( !array_key_exists( $field, $args ) ){
				throw new Exception( esc_html__( "The field $field is required", 'noo' ) );
			}
		}
		return $args;
	}
}